% this script generates a sequence of the MG tau=17 attractor from a random
% seed, so every call of this script produces another sequence.

samplelength = 10000;
initWashoutLength = 1000;

tau = 17;
incrementsperUnit = 10; 
genHistoryLength = tau * incrementsperUnit ;
seed = 1.2 * ones(genHistoryLength,1)+ 0.2 * (rand(genHistoryLength,1)-0.5);
oldval = 1.2;
genHistory = seed;
speedup = 1;

sample = zeros(samplelength,1);

step = 0;
for n = 1: samplelength + initWashoutLength
    for i = 1:incrementsperUnit * speedup
        step = step + 1;
        tauval = genHistory(mod(step,genHistoryLength)+1,1);
        newval = oldval + (0.2 * tauval/(1.0 + tauval^10) - 0.1 * oldval)/incrementsperUnit;
        genHistory(mod(step,genHistoryLength)+1,1) = oldval;
        oldval = newval;
    end
    if n > initWashoutLength
        sample(n - initWashoutLength,1) = newval;
    end
end


% transform to learning format
trainseq = sample(1:samplelength,1) - 1.0;
trainseq = tanh(trainseq);

% 
% 
% % using Matlabs delay differential equation solver
% 
% 
% ntot = samplelength;
% ntot = 100;
% options = ddeset('AbsTol', 1e-15, 'MaxStep', 1.0);
% sol = dde23(@MGDDEquation,[17],1.2*ones(1,1),[0,ntot],options);
% % 
% tint = linspace(1,ntot,ntot);
% sampleInt = deval(sol,tint);
% 
% % figure(3);
% % plot(sampleInt(1,1:ntot));
% 
% %transforming to training format
% sampleIntT = sampleInt - 1.0;
% sampleIntT = tanh(sampleIntT);
% 
% 
% % comparing 100-steps per unit time discrete simulation with Matlab dde23
% % solution
% 
% figure(2);
% plot(1:ntot,sampleT1000(1:ntot,1),1:ntot,sampleIntT(1,1:ntot))
% 
% figure(2);
% plot(1:ntot,sampleT100(1:ntot,1),1:ntot,sampleIntT(1,1:ntot))
% figure(3);
% plot(1:ntot,sampleT100(1:ntot,1),1:ntot,sampleT1000(1:ntot,1),1:ntot,sampleIntT(1,1:ntot))
% figure(4);
% plot(1:ntot,sampleT100(1:ntot,1),1:ntot,sampleT1000(1:ntot,1))

